/*
 * ms1.c : }WbNX^[ST
 *
 *               Copyright (C) 2000 by Makoto Hiroi
 *
 */
/*
        pY̓e

                O
              ^  _
    P------Q------R------S
      _  ^          _  ^             
        T              U
      ^  _          ^  _
    V------W------X------10
              _  ^  
                11

    1 - 12 ̐ĒɂS̘̐a
    S 26 ɂȂ悤ɂ

    
    0-2-5-7, 0-3-6-10, 7-8-9-10
    1-2-3-4, 1-5-8-11, 4-6-9-11
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define TRUE  1
#define FALSE 0
#define N     12
#define LINE  6

const char line[LINE][4] = {
  0, 2, 5, 7,  0, 3, 6, 10,  7, 8, 9, 10,
  1, 2, 3, 4,  1, 5, 8, 11,  4, 6, 9, 11
};

char star[N];
char use_number[N + 1];
int  count = 0;

/* o */
void print_star( void )
{
  int i;
  for( i = 0; i < N; i++ ){
    printf("%2d ", star[i] );
  }
  printf("\n");
}

/* ̌ */
int check_star( void )
{
  int i;
  for( i = 0; i < LINE; i++ ){
    int j, n;
    for( j = n = 0; j < 4; j++ ){
      n += star[ line[i][j] ];
    }
    if( n != 26 ) return FALSE;
  }
  return TRUE;
}

/* PȐ@ */
void search_star( int n )
{
  int i;
  if( n == N && check_star() ){
    count++;
    print_star();
  } else {
    for( i = 1; i <= N; i++ ){
      if( !use_number[i] ){
	use_number[i] = TRUE;
	star[n] = i;
	search_star( n + 1 );
        use_number[i] = FALSE;
      }
    }
  }
}

int main()
{
  int start, end;
  memset( use_number, 0, N + 1 );   /*  */
  printf("Ԃ̂łPn܂鏇݂̂`FbN\n");
  use_number[1] = TRUE;
  star[0] = 1;
  start = clock();
  search_star( 1 );
  end = clock();
  printf(" %d ,  %d\n", count, end - start );
  return 0;
}

/* end of file */
